#library(nloptr)
a0=1
c=0.2
d=0.3
A0=0;A1=0;A2=0;B0=0;B1=0;B2=0;C0=0;C1=0;C2=0;D0=0;D1=0;D2=0;E0=0;E1=0;E2=0
Y=0
m=20000
n=1000
rep=1000
tronc=m-100
Y=0
mu1=sqrt(2/pi)
#mu1=mean(abs(rt(10^7,6)))
for (p in c(1:rep))
{
  xi=rnorm((n+m),0,1)
  #xi=rt(n+m,6)
xi=xi/mu1
Y=rep(0,tronc)
k=c(1:tronc)
for (j in c(1:(n+m-tronc)))
  Y[j+tronc]=xi[j+tronc]*(a0+c*(sum(k^(d-1)*Y[j+tronc-k])))
X=Y[(m+1):(n+m)]
C=quantile(abs(X),0.9)
#ts.plot(X)
logLik=function(the)
  {z=0
  for (j in c(floor(n^0.5):n))
      z=z+(abs(X[j])-abs(the[1]+the[2]*(sum(c(1:(j-1))^(the[3]-1)*X[j-c(1:(j-1))]))))^2
                         return(z)
                              } # Top!!!
logLikFZ=function(the){
  z=0
  for (j in c(floor(n^0.5):n))
    z=z+(abs(X[j])^2-abs(the[1]+the[2]*(sum(c(1:(j-1))^(the[3]-1)*X[j-c(1:(j-1))])))^2)^2/
      (1+sum(abs(X[1:4])*(abs(X[1:4])>C))/C)^4
  return(z)
}
QMLE=optim(c(0.5,0.1,0.1),logLik,method = "L-BFGS-B",lower = c(0.1,-0.5,0), upper = c(100,0.5,0.5))
QMLEFZ=optim(c(1,0.1,0.25),logLikFZ,method = "L-BFGS-B",lower = c(0.1,-0.5,0), upper = c(100,0.5,0.5))
A0[p]=QMLE$par[1]
A1[p]=QMLE$par[2]
A2[p]=QMLE$par[3]
E0[p]=QMLEFZ$par[1]*mu1
E1[p]=QMLEFZ$par[2]*mu1
E2[p]=QMLEFZ$par[3]
}
mean(A0)
mean(A1)
mean(A2)
MSE0=(mean(A0-a0)^2+sd(A0)^2)^0.5; MSE1=(mean(A1-c)^2+sd(A1)^2)^0.5; MSE2=(mean(A2-d)^2+sd(A2)^2)^0.5
MSEFZ0=(mean(E0-a0)^2+sd(E0)^2)^0.5; MSEFZ1=(mean(E1-c)^2+sd(E1)^2)^0.5; MSEFZ2=(mean(E2-d)^2+sd(E2)^2)^0.5
round(c(MSE0,MSE1,MSE2,MSEFZ0,MSEFZ1,MSEFZ2),3)
